namespace THEasy.DB.Migrations
{
    using System;
    using System.Data.Entity.Migrations;
    
    public partial class first : DbMigration
    {
        public override void Up()
        {
            CreateTable(
                "dbo.Access",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        IdObject = c.Int(nullable: false),
                        IdUser = c.Int(nullable: false),
                        DateFrom = c.DateTime(nullable: false),
                        DateTo = c.DateTime(),
                        CanEnter = c.Boolean(nullable: false),
                        IsSuspect = c.Boolean(nullable: false),
                        IsBlocked = c.Boolean(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("dbo.EntityObject", t => t.IdObject, cascadeDelete: true)
                .ForeignKey("dbo.User", t => t.IdUser, cascadeDelete: true)
                .Index(t => t.IdObject)
                .Index(t => t.IdUser);
            
            CreateTable(
                "dbo.EntityObject",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(),
                        Path = c.String(),
                        Tag = c.String(),
                        ObjectType = c.Int(nullable: false),
                        IdParent = c.Int(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("dbo.EntityObject", t => t.IdParent)
                .Index(t => t.IdParent);
            
            CreateTable(
                "dbo.User",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Username = c.String(nullable: false),
                        Password = c.String(),
                        Email = c.String(),
                        Firstname = c.String(),
                        Lastname = c.String(),
                        IsAdUser = c.Boolean(nullable: false),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "dbo.ACL",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        IdObject = c.Int(nullable: false),
                        IdUser = c.Int(),
                        IdGroup = c.Int(),
                        DateFrom = c.DateTime(nullable: false),
                        DateTo = c.DateTime(),
                        Create = c.Boolean(nullable: false),
                        Read = c.Boolean(nullable: false),
                        Update = c.Boolean(nullable: false),
                        Delete = c.Boolean(nullable: false),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("dbo.Group", t => t.IdGroup)
                .ForeignKey("dbo.EntityObject", t => t.IdObject, cascadeDelete: true)
                .ForeignKey("dbo.User", t => t.IdUser)
                .Index(t => t.IdObject)
                .Index(t => t.IdUser)
                .Index(t => t.IdGroup);
            
            CreateTable(
                "dbo.Group",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Name = c.String(nullable: false, maxLength: 50),
                        IsDeleted = c.Boolean(nullable: false),
                        IdParent = c.Int(),
                        Parent_Id = c.Int(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("dbo.Group", t => t.Parent_Id)
                .Index(t => t.Parent_Id);
            
            CreateTable(
                "dbo.GroupUsers",
                c => new
                    {
                        Group_Id = c.Int(nullable: false),
                        User_Id = c.Int(nullable: false),
                    })
                .PrimaryKey(t => new { t.Group_Id, t.User_Id })
                .ForeignKey("dbo.Group", t => t.Group_Id, cascadeDelete: true)
                .ForeignKey("dbo.User", t => t.User_Id, cascadeDelete: true)
                .Index(t => t.Group_Id)
                .Index(t => t.User_Id);
            
        }
        
        public override void Down()
        {
            DropForeignKey("dbo.ACL", "IdUser", "dbo.User");
            DropForeignKey("dbo.ACL", "IdObject", "dbo.EntityObject");
            DropForeignKey("dbo.GroupUsers", "User_Id", "dbo.User");
            DropForeignKey("dbo.GroupUsers", "Group_Id", "dbo.Group");
            DropForeignKey("dbo.Group", "Parent_Id", "dbo.Group");
            DropForeignKey("dbo.ACL", "IdGroup", "dbo.Group");
            DropForeignKey("dbo.Access", "IdUser", "dbo.User");
            DropForeignKey("dbo.Access", "IdObject", "dbo.EntityObject");
            DropForeignKey("dbo.EntityObject", "IdParent", "dbo.EntityObject");
            DropIndex("dbo.GroupUsers", new[] { "User_Id" });
            DropIndex("dbo.GroupUsers", new[] { "Group_Id" });
            DropIndex("dbo.Group", new[] { "Parent_Id" });
            DropIndex("dbo.ACL", new[] { "IdGroup" });
            DropIndex("dbo.ACL", new[] { "IdUser" });
            DropIndex("dbo.ACL", new[] { "IdObject" });
            DropIndex("dbo.EntityObject", new[] { "IdParent" });
            DropIndex("dbo.Access", new[] { "IdUser" });
            DropIndex("dbo.Access", new[] { "IdObject" });
            DropTable("dbo.GroupUsers");
            DropTable("dbo.Group");
            DropTable("dbo.ACL");
            DropTable("dbo.User");
            DropTable("dbo.EntityObject");
            DropTable("dbo.Access");
        }
    }
}
