﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace THEasy.Model
{
    [Table("EntityObject")]
    public class EntityObject
    {
        [Key]
        public int Id { get; set; }
        public string Name { get; set; }
        public string Path { get; set; }
        public string Tag { get; set; }
        public ObjectType ObjectType { get; set; }

        public int? IdParent { get; set; }

        [ForeignKey("IdParent")]
        public EntityObject Parent { get; set; }

        public virtual ICollection<EntityObject> Childs { get; set; }

        public virtual ICollection<ACL> ACLs { get; set; }
    }
}
