﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.OData.Batch;
using System.Web.OData.Builder;
using System.Web.OData.Extensions;

namespace THEasy
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            // Web API configuration and services

            // Web API routes
            config.MapHttpAttributeRoutes();

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );

            ODataModelBuilder builder = new ODataConventionModelBuilder();
            builder.EntitySet<Model.Group>("Groups");
            builder.EntitySet<Model.User>("Users");
            builder.EntitySet<Model.EntityObject>("Objects");
            builder.EntitySet<Model.ACL>("ACLs");

            config.MapODataServiceRoute(
                routeName: "ODataRoute",
                routePrefix: "odata",
                model: builder.GetEdmModel()
                //,
                //batchHandler: new DefaultODataBatchHandler(GlobalConfiguration.DefaultServer)
                );

            config.EnsureInitialized();
        }
    }
}
