﻿using System.Linq;
using System.Threading.Tasks;
using Techorizon.Authorization.Common;

namespace THEasy
{
    public class AuthenticationClient: Techorizon.Authorization.Common.RestClient
    {
        public AuthenticationClient() :
            base(Properties.Settings.Default.AuthenticationUrl, new StandardEncryptionHelper())
        {

        }

        public async Task<UserStatusResult> AuthenticateAsync(string username, string password)
        {
            return await PostAsync<UserStatusResult>("account/Login", new LoginData
            {
                UserName = username.Split('\\').Last(),
                Password = password,
                Domain = username.Split('\\').FirstOrDefault() ?? Properties.Settings.Default.AutenticationDomain,
                DomainController = Properties.Settings.Default.AutenticationDomainController,
                UserNameController = Properties.Settings.Default.AuthenticationUsername,
                PasswordController = Properties.Settings.Default.AuthenticationPassword,
            });
        }

        public async Task<UserInformation> GetUserInformationAsync(string username)
        {
            return await PostAsync<UserInformation>("user/information", new LoginData
            {
                UserName = username.Split('\\').Last(),
                Domain = Properties.Settings.Default.AutenticationDomain,
                DomainController = Properties.Settings.Default.AutenticationDomainController,
                UserNameController = Properties.Settings.Default.AuthenticationUsername,
                PasswordController = Properties.Settings.Default.AuthenticationPassword,
            });
        }
    }
}