﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;

namespace THEasy
{
    public static class Extensions
    {
        public static string FullMessage(this Exception exception)
        {
            var sb = new StringBuilder();
            sb.AppendLine(exception.Message);

            var exc = exception.InnerException;
            while (exc != null)
            {
                sb.AppendLine(exc.Message);
                exc = exc.InnerException;
            }

            if (exception is System.Data.Entity.Validation.DbEntityValidationException)
            {
                sb.AppendLine();
                sb.AppendLine("Entity validation errors:");
                var e = exception as System.Data.Entity.Validation.DbEntityValidationException;
                foreach (var eve in e.EntityValidationErrors)
                {
                    foreach (var ve in eve.ValidationErrors)
                    {
                        sb.AppendFormat("Property name:{0}\nError message:{1}\n\n", ve.PropertyName, ve.ErrorMessage);
                    }
                }
            }

            return sb.ToString();
        }

        public static string FullMessageHTML(this Exception exception)
        {
            return exception.FullMessage().Replace("\n", "<br/>");
        }
    }
}