﻿using System.Web.Mvc;

namespace THEasy
{
    public class JsonExceptionFilterAttribute : FilterAttribute, IExceptionFilter
    {
        public void OnException(ExceptionContext filterContext)
        {
            filterContext.ExceptionHandled = true;
            filterContext.Result = new JsonResult
            {
                Data = new { success = false, message = filterContext.Exception.FullMessageHTML() },
                JsonRequestBehavior = JsonRequestBehavior.AllowGet
            };
        }
    }
}